package com.utopiaindustries.qualitycontrol.activities;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.utopiaindustries.qualitycontrol.R;
import com.utopiaindustries.qualitycontrol.models.QualitySaveResponse;

public class SummaryActivity extends AppCompatActivity {

    TextView txtPercentage, txtCutting, txtStitching, txtChecking, txtPacking, txtSubStore;
    String overallPercentage;
    ImageView img_back;
    QualitySaveResponse qualitySaveResponse;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_summary);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initialization();

        txtPercentage.setText(overallPercentage);
        txtCutting.setText(qualitySaveResponse.getCutting());
        txtStitching.setText(qualitySaveResponse.getStiching());
        txtChecking.setText(qualitySaveResponse.getChecking());
        txtPacking.setText(qualitySaveResponse.getPacking());
        txtSubStore.setText(qualitySaveResponse.getSub_Store());

        img_back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
                Intent intent = new Intent(SummaryActivity.this, HomeActivity.class);
                startActivity(intent);
            }
        });

    }

    public void initialization() {
        qualitySaveResponse = (QualitySaveResponse) getIntent().getSerializableExtra("Summary");
        overallPercentage = getIntent().getStringExtra("Percentage");

        /*Log.e("Cutting: ",""+qualitySaveResponse.getCutting());
        Log.e("Stitching: ",""+qualitySaveResponse.getStiching());
        Log.e("Checking: ",""+qualitySaveResponse.getChecking());
        Log.e("Packing: ",""+qualitySaveResponse.getPacking());
        Log.e("Substore: ",""+qualitySaveResponse.getSub_Store());
        Log.e("Overall: ",""+qualitySaveResponse.getOverAllPercentage());*/

        img_back = findViewById(R.id.img_back);
        txtPercentage = findViewById(R.id.txt_percentage);
        txtCutting =  findViewById(R.id.txt_cutting_percentage);
        txtStitching = findViewById(R.id.txt_stitching_percentage);
        txtChecking = findViewById(R.id.txt_checking_percentage);
        txtPacking = findViewById(R.id.txt_packing_percentage);
        txtSubStore = findViewById(R.id.txt_substore_percentage);
    }
}