package com.utopiaindustries.qualitycontrol.fragments;

import android.Manifest;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;

import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.core.content.FileProvider;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import com.utopiaindustries.qualitycontrol.R;
import com.utopiaindustries.qualitycontrol.activities.SummaryActivity;
import com.utopiaindustries.qualitycontrol.adapters.ImageAdapter;
import com.utopiaindustries.qualitycontrol.adapters.ItemStepsAdapter;
import com.utopiaindustries.qualitycontrol.helper.Helper;
import com.utopiaindustries.qualitycontrol.helper.Preference;
import com.utopiaindustries.qualitycontrol.utils.ImageSelectionListener;
import com.utopiaindustries.qualitycontrol.utils.ProgressDialogFragment;
import com.utopiaindustries.qualitycontrol.viewmodels.HomeViewModel;
import com.utopiaindustries.qualitycontrol.viewmodels.ItemModel;
import com.utopiaindustries.qualitycontrol.viewmodels.QualityControl;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Objects;
import java.util.function.Consumer;

import pub.devrel.easypermissions.AfterPermissionGranted;
import pub.devrel.easypermissions.AppSettingsDialog;
import pub.devrel.easypermissions.EasyPermissions;

public class SubStoreFragment extends Fragment implements EasyPermissions.PermissionCallbacks,
        ImageSelectionListener {

    RecyclerView recyclerView, imageRecyclerView;
    ImageAdapter imageAdapter;
    String filePath = "no_pic";

    private static final int CAMERA_REQUEST = 104;
    private static final int GALLERY_REQUEST = 204;

    Button nextButton;
    ImageButton imagePicker, deleteImage;

    ArrayList<byte[]> imageList = new ArrayList<>();
    EditText etPercentage, etRemarks;
    //QualityControlViewModel viewModel;
    List<ItemModel> itemModelList = new ArrayList<>();
    ItemStepsAdapter adapter;
    private int selectedPosition = -1;
    HomeViewModel homeViewModel;
    private int deletePosition = -1;

    // Activity Result Launcher for Gallery
    private final ActivityResultLauncher<Intent> imagePickerLauncher =
            registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {
                if (result.getResultCode() == requireActivity().RESULT_OK && result.getData() != null) {
                    Uri selectedImage = result.getData().getData();
                    if (selectedPosition != -1 && selectedImage != null) {
                        //imageView.setImageURI(selectedImage);

                        uriToByteArrayAsync(
                                getContext(),
                                selectedImage,
                                100,  // Target size in KB
                                compressedImage -> {
                                    // Handle the compressed image here, e.g., display it
                                    requireActivity().runOnUiThread(() -> {
                                        itemModelList.get(selectedPosition).setImageUri(compressedImage);
                                        List<byte[]> tempList = new ArrayList<>();
                                        tempList.add(compressedImage);
                                        itemModelList.get(selectedPosition).setImageArrayList(tempList);
                                        adapter.notifyItemChanged(selectedPosition);
                                    });
                                },
                                error -> {
                                    // Handle any errors
                                    requireActivity().runOnUiThread(() -> {
                                        Toast.makeText(getContext(), "Error compressing image: " + error.getMessage(), Toast.LENGTH_SHORT).show();
                                    });
                                }
                        );
                    }
                }
            });

    // Activity Result Launcher for Camera
    private final ActivityResultLauncher<Intent> cameraLauncher =
            registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {
                Uri contentUri = Uri.fromFile(new File((filePath)));

                uriToByteArrayAsync(
                        getContext(),
                        contentUri,
                        100,  // Target size in KB
                        compressedImage -> {
                            // Handle the compressed image here, e.g., display it
                            requireActivity().runOnUiThread(() -> {
                                itemModelList.get(selectedPosition).setImageUri(compressedImage);
                                List<byte[]> tempList = new ArrayList<>();
                                tempList.add(compressedImage);
                                itemModelList.get(selectedPosition).setImageArrayList(tempList);
                                adapter.notifyItemChanged(selectedPosition);
                            });
                        },
                        error -> {
                            // Handle any errors
                            requireActivity().runOnUiThread(() -> {
                                Toast.makeText(getContext(), "Error compressing image: " + error.getMessage(), Toast.LENGTH_SHORT).show();
                            });
                        }
                );

                if (result.getResultCode() == requireActivity().RESULT_OK && result.getData() != null) {

                    Uri selectedImage = result.getData().getData();
                    if (selectedImage != null) {
                        //imageView.setImageURI(selectedImage);
                       // Log.e("Selected-Image: ", "" + selectedImage);
                    }
                }
            });

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.fragment_sub_store, container, false);

        initializeLayout(view);

        /*List<Item> itemList = new ArrayList<>();
        itemList.add(new Item("Sort", 0));
        itemList.add(new Item("Set in Order", 0));
        itemList.add(new Item("Shine", 0));
        itemList.add(new Item("Standardize", 0));
        itemList.add(new Item("Sustain", 0));
        itemList.add(new Item("Safety", 0));*/

        //New Implemented------------------
        if (Helper.getArrayList(Helper.listSubStore, getActivity()) != null) {
            itemModelList.clear();
            itemModelList.addAll(Helper.getArrayList(Helper.listSubStore, getActivity()));
            //Log.e("itemModelList-size: ",""+itemModelList.size());

            if (itemModelList != null) {
                adapter = new ItemStepsAdapter(getActivity(), itemModelList, this);
                recyclerView.setLayoutManager(new LinearLayoutManager(getActivity()));
                recyclerView.setAdapter(adapter);
            } else {
                for (int i = 1; i < 7; i++) {
                    itemModelList.add(new ItemModel(5, i, 0, "0", "", 0, null, null));
                }

                adapter = new ItemStepsAdapter(getActivity(), itemModelList, this);
                recyclerView.setLayoutManager(new LinearLayoutManager(getActivity()));
                recyclerView.setAdapter(adapter);
            }
        } else {
            for (int i = 1; i < 7; i++) {
                itemModelList.add(new ItemModel(5, i, 0, "0", "", 0, null, null));
            }
            adapter = new ItemStepsAdapter(getActivity(), itemModelList, this);
            recyclerView.setLayoutManager(new LinearLayoutManager(getActivity()));
            recyclerView.setAdapter(adapter);
        }

        //----------------------------------

        imageAdapter = new ImageAdapter(imageList, getActivity());
        imageRecyclerView.setAdapter(imageAdapter);

        imagePicker.setOnClickListener(v -> {
            showAlertDialog(view);
        });

        deleteImage.setOnClickListener(v -> {
            if (!imageList.isEmpty()) {
                imageList.remove(imageList.size() - 1);
            } else {
                System.out.println("The list is empty");
            }
            imageAdapter.notifyDataSetChanged();
        });

        nextButton.setOnClickListener(v -> {
            /*Intent intent = new Intent(getActivity(), SummaryActivity.class);
            startActivity(intent);
            getActivity().finish();*/

            /*Log.e("AdapterData", "siteID: " + siteID +
                    ", unitId: " + unitId +
                    ", departId: " + departId +
                    ", floorId: " + floorId );

            Log.e("------------------","------------");*/

            /*for (ItemModel item : tempList) {
                Log.e("AdapterData", "ProcessId: " + item.getProcessId() +
                        ", StepId: " + item.getStepId() +
                        ", SpinnerSelection: " + item.getSelectedOption() +
                        ", Rating: " + item.getRating() +
                        ", Percentage: " + item.getPercentage() +
                        ", Remarks: " + item.getRemarks() +
                        ", ImageList: " + item.getImageArrayList() +
                        ", Image: " + Arrays.toString(item.getImageUri()));
            }*/

            AlertDialog.Builder builder = new AlertDialog.Builder(requireContext());
            builder.setTitle("Are you sure to save Report?")
                    .setItems(new String[]{"Yes", "Cancel"}, (dialog, which) -> {
                        if (which == 0) {

                            List<ItemModel> updatedItemList = itemModelList; // Or adapter.getItemList()

                            /*for (ItemModel item : updatedItemList) {
                                Log.e("AdapterData", "ProcessId: " + item.getProcessId() +
                                        ", StepId: " + item.getStepId() +
                                        ", SpinnerSelection: " + item.getSelectedOption() +
                                        ", Rating: " + item.getRating() +
                                        ", Percentage: " + item.getPercentage() +
                                        ", Remarks: " + item.getRemarks() +
                                        ", ImageList: " + item.getImageArrayList());
                            }*/

                            Helper.saveArrayList(itemModelList, Helper.listSubStore, getActivity());
                            //viewModel.appendToQualityControlItemList(itemModelList);

                            int siteID = Integer.parseInt(Preference.getMyStringPref(Helper.project_file, Helper.locationSiteId, getActivity()));
                            int unitId = Integer.parseInt(Preference.getMyStringPref(Helper.project_file, Helper.unitId, getActivity()));
                            int departId = Integer.parseInt(Preference.getMyStringPref(Helper.project_file, Helper.departmentId, getActivity()));
                            int floorId = Integer.parseInt(Preference.getMyStringPref(Helper.project_file, Helper.floorId, getActivity()));

                            List<ItemModel> tempList = new ArrayList<>();
                            tempList.addAll(Helper.getArrayList(Helper.listCutting, getActivity()));
                            tempList.addAll(Helper.getArrayList(Helper.listStitching, getActivity()));
                            tempList.addAll(Helper.getArrayList(Helper.listChecking, getActivity()));
                            tempList.addAll(Helper.getArrayList(Helper.listPacking, getActivity()));
                            tempList.addAll(Helper.getArrayList(Helper.listSubStore, getActivity()));
                            String generatedBy = Preference.getMyStringPref(Helper.project_file,Helper.logInUser,getActivity());

                            /*Log.e("AdapterData-1", "siteID: " + siteID +
                                    ", unitId: " + unitId +
                                    ", departId: " + departId +
                                    ", floorId: " + floorId);*/

                            QualityControl qualityControl = new QualityControl(generatedBy,siteID,unitId,departId,floorId,tempList);

                            /*Log.e("---------------","-----------------");

                            Log.e("AdapterData-2", "Generated-By: " + qualityControl.getGeneratedBy() +
                                    ", siteID: " + qualityControl.getSiteId() +
                                    ", unitId: " + qualityControl.getUnitId() +
                                    ", departId: " + qualityControl.getDepartmentId() +
                                    ", floorId: " + qualityControl.getFloorId());*/

                            homeViewModel.saveQualityControlData(qualityControl);
                        } else {
                            dialog.dismiss();
                        }
                    })
                    .show();

        });

        return view;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
    }

    private void initializeLayout(View view) {

        //viewModel = new ViewModelProvider(requireActivity()).get(QualityControlViewModel.class);
        homeViewModel = new ViewModelProvider(requireActivity()).get(HomeViewModel.class);

        etPercentage = view.findViewById(R.id.et_percentage);
        etRemarks = view.findViewById(R.id.et_remarks);
        imagePicker = view.findViewById(R.id.image_picker);
        deleteImage = view.findViewById(R.id.delete_image);
        nextButton = view.findViewById(R.id.btn_next);
        recyclerView = view.findViewById(R.id.recycler_view_substore);
        imageRecyclerView = view.findViewById(R.id.imageRecyclerView);
        imageRecyclerView.setLayoutManager(new LinearLayoutManager(getActivity(), LinearLayoutManager.HORIZONTAL, false));

        homeViewModel.getLoadingState().observe(getActivity(), isLoading -> {
            if (isLoading != null && isLoading) {
                showProgressDialog();
            } else {
                dismissProgressDialog();
            }
        });

        homeViewModel.getErrorMessage().observe(getActivity(), errorResponse -> {
            if (errorResponse.isEmpty()) {
                Toast.makeText(getActivity(), "Something went wrong", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(getActivity(), errorResponse, Toast.LENGTH_SHORT).show();
            }

        });

        homeViewModel.getUserLiveData().observe(getActivity(), qcResponse -> {
            if (qcResponse != null) {
                /*Log.e("qcResponse: ", "" + qcResponse);
                Log.e("","Status: " + qcResponse.getStatus() + " Message: " + qcResponse.getMessage() + " Percentage: " + qcResponse.getOverAllPercentage());
                Log.e("","Cut: " + qcResponse.getCutting() + " Stitch: " + qcResponse.getStiching() + " Check: " + qcResponse.getChecking());
                Log.e("","Pack: " + qcResponse.getPacking() + " Substore: " + qcResponse.getSub_Store());*/
                Preference.remove(Helper.project_file, Helper.departmentId, getActivity());
                Preference.remove(Helper.project_file, Helper.departmentName, getActivity());

                Preference.remove(Helper.project_file, Helper.locationSiteId, getActivity());
                Preference.remove(Helper.project_file, Helper.locationSiteName, getActivity());

                Preference.remove(Helper.project_file, Helper.unitId, getActivity());
                Preference.remove(Helper.project_file, Helper.unitName, getActivity());

                Preference.remove(Helper.project_file, Helper.floorId, getActivity());
                Preference.remove(Helper.project_file, Helper.floorName, getActivity());

                Helper.RemoveArrayList(Helper.listCutting,getActivity());
                Helper.RemoveArrayList(Helper.listStitching,getActivity());
                Helper.RemoveArrayList(Helper.listChecking,getActivity());
                Helper.RemoveArrayList(Helper.listPacking,getActivity());
                Helper.RemoveArrayList(Helper.listSubStore,getActivity());

                //Preference.setMyStringPref(Helper.project_file, Helper.InProcess, getActivity(), "false");

                getActivity().finish();
                Intent intent = new Intent(getActivity(), SummaryActivity.class);
                intent.putExtra("Percentage", qcResponse.getOverAllPercentage());
                intent.putExtra("Summary", qcResponse);
                startActivity(intent);
            }
        });
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String[] permissions,
                                           @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);

        // EasyPermissions handles the request result.
        EasyPermissions.onRequestPermissionsResult(requestCode, permissions, grantResults, this);
    }

    @Override
    public void onPermissionsGranted(int requestCode, @NonNull List<String> perms) {

    }

    @Override
    public void onPermissionsDenied(int requestCode, @NonNull List<String> perms) {
        if (EasyPermissions.somePermissionPermanentlyDenied(this, perms)) {
            new AppSettingsDialog.Builder(this).build().show();
        }
    }

    public void uriToByteArrayAsync(
            Context context,
            Uri uri,
            int targetSizeInKB,
            Consumer<byte[]> onSuccess,
            Consumer<Exception> onError
    ) {
        new Thread(() -> {
            try {
                int targetSizeInBytes = targetSizeInKB * 1024;

                // Load the image as a Bitmap without scaling
                Bitmap bitmap;
                try (InputStream inputStream = context.getContentResolver().openInputStream(uri)) {
                    bitmap = BitmapFactory.decodeStream(inputStream);
                }

                if (bitmap == null) {
                    throw new IOException("Failed to decode image from URI.");
                }

                ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
                int minQuality = 10;
                int maxQuality = 100;
                int quality = maxQuality;

                // Binary search for the best quality that meets the target size
                while (minQuality <= maxQuality) {
                    byteArrayOutputStream.reset();
                    bitmap.compress(Bitmap.CompressFormat.JPEG, quality, byteArrayOutputStream);

                    int byteSize = byteArrayOutputStream.size();
                    if (byteSize > targetSizeInBytes) {
                        maxQuality = quality - 1;
                    } else {
                        minQuality = quality + 1;
                    }
                    quality = (minQuality + maxQuality) / 2;
                }

                onSuccess.accept(byteArrayOutputStream.toByteArray());
            } catch (IOException e) {
                onError.accept(e);
            }
        }).start();
    }

    private boolean hasGalleryPermission() {
        String[] perms = {};

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES};
        } else {
            perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE};
        }

        return EasyPermissions.hasPermissions(requireActivity(), perms);
    }

    private boolean hasCameraPermission() {
        String[] perms = {};
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            //Log.e("TIRAMISU: ","***");
            perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES, Manifest.permission.CAMERA};
        } else {
            //Log.e("Not-TIRAMISU: ","***");
            perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA};

        }

        //Log.e("perms: ",""+perms);
        return EasyPermissions.hasPermissions(requireActivity(), perms);
    }

    private File createImageFile() throws IOException {
        // Create an image file name
        String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
        String imageFileName = "JPEG_" + timeStamp + "_";
        File storageDir = requireActivity().getExternalFilesDir(Environment.DIRECTORY_PICTURES);
        File image = File.createTempFile(
                imageFileName,  /* prefix */
                ".jpg",         /* suffix */
                storageDir      /* directory */
        );

        filePath = image.getAbsolutePath();
        return image;
    }

    public void showAlertDialog(View view) {
        ViewGroup viewGroup = view.findViewById(android.R.id.content);

        TextView txt_camera, txt_gallery, txt_cancel;

        AlertDialog.Builder builder = new AlertDialog.Builder(requireActivity());
        View view1 = LayoutInflater.from(getActivity()).inflate(R.layout.custom_layout, viewGroup, false);
        builder.setCancelable(false);
        builder.setView(view1);

        txt_camera = view1.findViewById(R.id.txt_camera);
        txt_gallery = view1.findViewById(R.id.txt_gallery);
        txt_cancel = view1.findViewById(R.id.txt_cancel);

        AlertDialog alertDialog = builder.create();
        Objects.requireNonNull(alertDialog.getWindow()).setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));

        txt_camera.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                alertDialog.dismiss();
                openCamera();
            }
        });

        txt_gallery.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                alertDialog.dismiss();
                openGallery();
            }
        });

        txt_cancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                alertDialog.dismiss();
            }
        });

        alertDialog.show();
    }

    @AfterPermissionGranted(CAMERA_REQUEST)
    public void openCamera() {
        if (hasCameraPermission()) {
            try {
                Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                File photoFile = null;
                try {
                    photoFile = createImageFile();
                } catch (IOException ex) {
                    // Error occurred while creating the File
                }

                if (photoFile != null) {
                    Uri photoURI = FileProvider.getUriForFile(requireActivity(),
                            "com.utopiaindustries.qualitycontrol",
                            photoFile);
                    takePictureIntent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI);
                    //startActivityForResult(takePictureIntent, CAMERA_REQUEST);
                    cameraLauncher.launch(takePictureIntent);
                }
            } catch (ActivityNotFoundException e) {
                Toast.makeText(getContext(), "Camera app not found", Toast.LENGTH_SHORT).show();
            }
        } else {
            // Ask for one permission
            String[] perms = {};
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES, Manifest.permission.CAMERA};
            } else {
                perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA};
            }

            EasyPermissions.requestPermissions(this, getString(R.string.rationale_camera), CAMERA_REQUEST, perms);
        }
    }

    @AfterPermissionGranted(GALLERY_REQUEST)
    public void openGallery() {
        if (hasGalleryPermission()) {
            // Have permission, do the thing!
            Intent galleryIntent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
            // Start the Intent
            //startActivityForResult(galleryIntent, GALLERY_REQUEST);
            imagePickerLauncher.launch(galleryIntent);
        } else {
            // Ask for one permission
            String[] perms = {};
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES};
            } else {
                perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE};

            }
            EasyPermissions.requestPermissions(this, getString(R.string.rationale_camera), GALLERY_REQUEST, perms);
        }
    }

    @Override
    public void onSelectImage(int position) {
        selectedPosition = position;

        // Show dialog to choose between camera and gallery
        AlertDialog.Builder builder = new AlertDialog.Builder(requireContext());
        builder.setTitle("Select Image")
                .setItems(new String[]{"Camera", "Gallery"}, (dialog, which) -> {
                    if (which == 0) { // Camera
                        openCamera();
                    } else { // Gallery
                        openGallery();
                    }
                })
                .show();
    }

    @Override
    public void onDeleteImage(int position) {
        deletePosition = position;

        if (itemModelList.get(deletePosition).getImageArrayList() != null && !itemModelList.get(deletePosition).getImageArrayList().isEmpty()) {
            itemModelList.get(deletePosition).setImageArrayList(null);
            itemModelList.get(deletePosition).setImageUri(null);
            adapter.notifyItemChanged(deletePosition);
        }

    }

    public void showProgressDialog() {
        ProgressDialogFragment progressDialog = new ProgressDialogFragment();
        progressDialog.setCancelable(false);
        progressDialog.show(requireActivity().getSupportFragmentManager(), "progressDialog");
    }

    public void dismissProgressDialog() {
        ProgressDialogFragment progressDialog = (ProgressDialogFragment) requireActivity().getSupportFragmentManager().findFragmentByTag("progressDialog");
        if (progressDialog != null) {
            progressDialog.dismiss();
        }
    }
}